comment %

Algo	: SHACAL (by Handschuh & Naccache)
Block	: 20 bytes
Key	: 512 bits


	push	offset key
	call	shacal_setkey

	push	offset plain
	push	offset cipher
	call	shacal_encrypt

	push	offset cipher
	push	offset decrypted_plain
	call	shacal_decrypt

	call	shacal_clear


26.06.2002 WiteG//xtreeme (witeg@poczta.fm, www.witeg.prv.pl)

%
.code
shacal_setkey	proc	ptrKey:DWORD

	pushad
	mov	ecx, 16
	mov	esi, ptrKey
	mov	edi, offset _temp_buffer
	cld

@@:
	lodsd
	bswap	eax
	stosd
	dec	ecx
	jnz	@B

	mov	cl, 64
@@:
	mov	eax, dword ptr [edi- 3*4]
	xor	eax, dword ptr [edi- 8*4]
	xor	eax, dword ptr [edi-14*4]
	xor	eax, dword ptr [edi-16*4]
	rol	eax, 1
	stosd
	dec	ecx
	jnz	@B

	popad
	ret

shacal_setkey	endp

shacal_encrypt	proc
	pushad
	mov	old_esp, esp

	mov	esi, dword ptr [esp +28h]

	mov	eax, dword ptr [esi + 0]
	mov	ebx, dword ptr [esi + 4]
	mov	ecx, dword ptr [esi + 8]
	mov	edx, dword ptr [esi +12]
	mov	ebp, dword ptr [esi +16]

	mov	esi, offset _temp_buffer
@@:
	mov	esp, eax
	rol	esp, 5
	add	ebp, esp
	add	ebp, dword ptr [esi]
	
	mov	esp, ecx
	xor	esp, edx
	and	esp, ebx
  	xor	esp, edx

	lea	ebp, [ebp + esp + 05A827999h]

	ror	ebx, 2

	xchg	edx, ebp
	xchg	edx, ecx
	xchg	ebx, ecx
	xchg	ebx, eax

	add	esi, 4
	cmp	esi, offset _temp_buffer + 20*4
	jnz	@B

@@:
	mov	esp, eax
	rol	esp , 5
	add	ebp, esp
	add	ebp, dword ptr [esi]

	mov	esp, ebx
	xor	esp, ecx
	xor	esp, edx

	lea	ebp, [ebp + esp + 06ED9EBA1h]
	
	ror	ebx, 2

	xchg	edx, ebp
	xchg	edx, ecx
	xchg	ebx, ecx
	xchg	ebx, eax

	add	esi, 4
	cmp	esi, offset _temp_buffer + 40*4
	jnz	@B

@@:
	mov	esp, eax
	rol	esp , 5
	add	ebp, esp
	add	ebp, dword ptr [esi]

	mov	esp, ebx
	or	esp, ecx
	and	esp, edx
	mov	edi, ebx
	and	edi, ecx
	or	edi, esp

	lea	ebp, [ebp + edi + 08F1BBCDCh]
	
	ror	ebx, 2

	xchg	edx, ebp
	xchg	edx, ecx
	xchg	ebx, ecx
	xchg	ebx, eax

	add	esi, 4
	cmp	esi, offset _temp_buffer + 60*4
	jnz	@B

@@:
	mov	esp, eax
	rol	esp , 5
	add	ebp, esp
	add	ebp, dword ptr [esi]

	mov	esp, ebx
	xor	esp, ecx
	xor	esp, edx

	lea	ebp, [ebp + esp + 0CA62C1D6h]
	
	ror	ebx, 2

	xchg	edx, ebp
	xchg	edx, ecx
	xchg	ebx, ecx
	xchg	ebx, eax

	add	esi, 4
	cmp	esi, offset _temp_buffer + 80*4
	jnz	@B

	mov	esp, dword ptr [old_esp]
	mov	esi, dword ptr [esp +24h]
	mov	dword ptr [esi + 0], eax
	mov	dword ptr [esi + 4], ebx
	mov	dword ptr [esi + 8], ecx
	mov	dword ptr [esi +12], edx
	mov	dword ptr [esi +16], ebp

	popad
	ret	8
shacal_encrypt	endp

shacal_decrypt	proc

	pushad
	mov	old_esp, esp

	mov	esi, dword ptr [esp +28h]

	mov	eax, dword ptr [esi + 0]
	mov	ebx, dword ptr [esi + 4]
	mov	ecx, dword ptr [esi + 8]
	mov	edx, dword ptr [esi +12]
	mov	ebp, dword ptr [esi +16]

	mov	esi, offset _temp_buffer + 79*4
@@:
	xchg	eax, ebx
	xchg	ebx, ecx
	xchg	ecx, edx
	xchg	edx, ebp

	rol	ebx, 2
	
	mov	esp, eax
	rol	esp , 5
	sub	ebp, esp
	sub	ebp, dword ptr [esi]

	mov	esp, ebx
	xor	esp, ecx
	xor	esp, edx

	sub	ebp, esp
	sub	ebp, 0CA62C1D6h

	sub	esi, 4
	cmp	esi, offset _temp_buffer + 59*4
	jnz	@B

@@:
	xchg	eax, ebx
	xchg	ebx, ecx
	xchg	ecx, edx
	xchg	edx, ebp

	rol	ebx, 2
	
	mov	esp, eax
	rol	esp , 5
	sub	ebp, esp
	sub	ebp, dword ptr [esi]

	mov	esp, ebx
	or	esp, ecx
	and	esp, edx
	mov	edi, ebx
	and	edi, ecx
	or	edi, esp

	sub	ebp, edi
	sub	ebp, 08F1BBCDCh
	
	sub	esi, 4
	cmp	esi, offset _temp_buffer + 39*4
	jnz	@B

@@:
	xchg	eax, ebx
	xchg	ebx, ecx
	xchg	ecx, edx
	xchg	edx, ebp

	rol	ebx, 2
	
	mov	esp, eax
	rol	esp , 5
	sub	ebp, esp
	sub	ebp, dword ptr [esi]

	mov	esp, ebx
	xor	esp, ecx
	xor	esp, edx

	sub	ebp, esp
	sub	ebp, 06ED9EBA1h

	sub	esi, 4
	cmp	esi, offset _temp_buffer + 19*4
	jnz	@B

@@:
	xchg	eax, ebx
	xchg	ebx, ecx
	xchg	ecx, edx
	xchg	edx, ebp

	rol	ebx, 2
	
	mov	esp, eax
	rol	esp , 5
	sub	ebp, esp
	sub	ebp, dword ptr [esi]
	
	mov	esp, ecx
	xor	esp, edx
	and	esp, ebx
  	xor	esp, edx

	sub	ebp, esp
	sub	ebp, 05A827999h

	sub	esi, 4
	cmp	esi, offset _temp_buffer - 4
	jnz	@B

	mov	esp, dword ptr [old_esp]
	mov	esi, dword ptr [esp +24h]
	mov	dword ptr [esi + 0], eax
	mov	dword ptr [esi + 4], ebx
	mov	dword ptr [esi + 8], ecx
	mov	dword ptr [esi +12], edx
	mov	dword ptr [esi +16], ebp

	popad
	ret	8
shacal_decrypt	endp


shacal_clear	proc

	pushad
	mov	edi, offset _temp_buffer
	mov	ecx, 81
	xor	eax, eax
	cld
	rep	stosd
	popad
	ret

shacal_clear	endp

.data?
_temp_buffer 	dd 80 dup(?)
old_esp		dd ?